﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Collections;
using System.Net.Mail;

namespace StokerApp
{
    public partial class Form5 : Form
    {
        private static int antalMagasinAlarmerAfsendt = 0;
        public Form5()
        {
            InitializeComponent();
        }

        private void Form5_Load(object sender, EventArgs e)
        {
            if (File.Exists("url.txt"))
            {
 
                // OK vi lader timeren køre videre
            }
            else
            {
                timer1.Enabled = false;
                updatetime.Text = "Timer stoppet..";
            }
        }

        private string SøgOgErstatTegn(string s)
        {
            string søg1 = "&aelig;";
            string søg2 = "&oslash;";
            string søg3 = "&deg;";
            string søg4 = "&Oslash;";
            char degree = (char)176;
            s = s.Replace(søg1, "æ");
            s = s.Replace(søg2, "ø");
            s = s.Replace(søg3, degree.ToString());
            s = s.Replace(søg4, "Ø");
            return s;
        }

        private void checkSendAlarm(string magasinNU)
        {
            int talMagasinNU = Convert.ToInt32(magasinNU);
            StreamReader sr = new StreamReader("alarm.txt");
            string minsmtp = sr.ReadLine();
            string modtager = sr.ReadLine();
            string magasingrænse = sr.ReadLine();
            int portnummer = Convert.ToInt32(sr.ReadLine());
            string afsender = sr.ReadLine();
            string kodeord = sr.ReadLine();
            string timersekunder = sr.ReadLine();
            bool magasinalarm = sr.ReadLine().Equals("ja");
            sr.Close();
            int talMagasinGrænse = Convert.ToInt32(magasingrænse);
            int timerinterval = (Convert.ToInt32(timersekunder) * 1000);
            timer1.Interval = timerinterval;

            if ((talMagasinNU < talMagasinGrænse) && magasinalarm && (antalMagasinAlarmerAfsendt < 2))   // så skal der sender alarm-mail
            {
                try
                {

                    MailMessage msg = new MailMessage(afsender, modtager, "Alarm magasingrænse", "Stokeralarm. Magasin er nu på " + magasinNU + " kg. Grænsen er nået");
                    SmtpClient mailClient = new SmtpClient(minsmtp, portnummer);
                    // fungerer med smtp.gmail.com og port 587 for afsendelse.
                    NetworkCredential NetCrd = new NetworkCredential(afsender, kodeord);
                    mailClient.UseDefaultCredentials = false;
                    mailClient.Credentials = NetCrd;
                    mailClient.EnableSsl = true;
                    mailClient.DeliveryMethod = SmtpDeliveryMethod.Network;
                    mailClient.Send(msg);
                    antalMagasinAlarmerAfsendt++;
                    alarmsendt.Text = "ALARM AFSENDT!";
                }
                catch (Exception ex)
                {
                    updatetime.Text = ex.ToString();
                }
            }
            else
            {
                if (antalMagasinAlarmerAfsendt > 0)
                {
                    alarmsendt.Text = "Check mail for alarmer";
                }
                else
                {
                    alarmsendt.Text = "";
                    // Der skal ikke sendes alarm
                }
            }

        }

        private object getTrimmedValue(string inputvalue)
        {
            //Split strengen i 5 dele med \" som adskillelsestegn
            char[] adskillelsestegn = new char[] { '\"' };
            string[] splitdata = inputvalue.Split(adskillelsestegn);
            char[] trimchar = new char[] { '\"' };
            string navn = splitdata[0].TrimEnd(trimchar);
            string[] navnogværdi = new string[2];
            // nr. 1 indeholder parameter og nr.3 værdien
            navnogværdi[0] = splitdata[1];
            navnogværdi[1] = splitdata[3];
            return navnogværdi;

        }

        private string trimSidsteOpdatering(string lastupd)
        {
            char[] adskillelsestegn = new char[] { '<' };
            string[] splitdata = lastupd.Split(adskillelsestegn);
            // splitter i 3 strenge, hvor nr 2 indeholder det relevante (bør kunne forbedres - ikke særlig fikst..)
            int længde = splitdata[1].Length;
            char[] venstretrim = new char[] { '>' };
            string s = splitdata[1].Substring(21);
            return s;

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            WebClient klient = new WebClient();
            if (File.Exists("url.txt"))
            {
                StreamReader urlsr = new StreamReader("url.txt");
                string stokerurl = urlsr.ReadLine();
                urlsr.Close();
                try
                {
                    Stream data = klient.OpenRead(stokerurl+"/values.txt");
                    StreamReader sr = new StreamReader(data);
                    string s = sr.ReadToEnd();
                    sr.Close();
                    data.Close();
                    Stream sidsteopdatering = klient.OpenRead(stokerurl + "/lastupdate.html");
                    StreamReader sr2 = new StreamReader(sidsteopdatering);
                    string lastupdate = sr2.ReadToEnd();
                    string opdat = trimSidsteOpdatering(lastupdate);
                    ftpupdate.Text = "Seneste FTP: " + opdat;
                    sr2.Close();
                    // erstat æø og gradtegn koder
                    s = SøgOgErstatTegn(s);

                    // fjern brackets først og sidst
                    char[] venstretrim = new char[] { '[' };
                    char[] højretrim = new char[] { ']' };
                    string strim = s.TrimStart(venstretrim);
                    strim = strim.TrimEnd(højretrim);
                    // split efter højreparentes
                    char[] adskillelsestegn = new char[] { '}' };
                    string[] stokerdata = strim.Split(adskillelsestegn);

                    ArrayList al = new ArrayList();
                    // Put alle data i arraylist og fjern uønskede tegn - arraylist er lidt oldschool
                    for (int i = 0; i < stokerdata.Length - 1; i++)
                    {
                        al.Add(getTrimmedValue(stokerdata[i]));
                    }

                    string[] infostring = (string[])al[0]; // indeholder oplysning om tændt/slukket
                    //status.Text = "Fyrets tilstand er: " + infostring[1];
                    char[] spacetrim = new char[] { ' ' };
                    infostring[1] = infostring[1].TrimStart(spacetrim);
                    infostring[1] = infostring[1].TrimEnd(spacetrim);
                    infostring[1] = infostring[1].ToUpper();
                    //infostring[1] = infostring[1].TrimEnd(
                    if (infostring[1].Equals("SLUKKET"))
                    {
                        status.ForeColor = System.Drawing.Color.Red;
                    }
                    else
                    {
                        status.ForeColor = System.Drawing.Color.Green;
                    }
                    status.Text = infostring[1];
                    string[] kedeltemp = (string[])al[5]; //kedeltemperatur
                    char gradtegn = (char)176;
                    fremløb.Text = "Fremløb: " + kedeltemp[1] + gradtegn.ToString();
                    string[] vvb = (string[])al[13]; //vvb
                    vvbtemp.Text = "VVB: " + vvb[1] + gradtegn.ToString();
                    string[] returtemp = (string[])al[6]; //returtemperatur
                    retur.Text = "Retur: " + returtemp[1] + gradtegn.ToString();
                    string[] røg = (string[])al[7]; //røgtemperatur
                    røgtemp.Text = "Røgtmp: " + røg[1] + gradtegn.ToString();
                    string[] skakttemperatur = (string[])al[8]; //skakt
                    skakt.Text = "Skakt: " + skakttemperatur[1] + gradtegn.ToString();
                    string[] alarmtilstand = (string[])al[1];
                    Alarm.Text = "Alarm: " + alarmtilstand[1];
                    string[] magasinindhold = (string[])al[11];
                    magasin.Text = "Magasin: " + magasinindhold[1] + " kg";
                    string[] effektkw = (string[])al[3]; //effekt
                    effekt.Text = "Effekt er: " + effektkw[1] + "kW";
                    string[] sneglydelse = (string[])al[21]; //snegl ydelse pr 6 min
                    snegl.Text = "Snegl/6 min: " + sneglydelse[1] + " g";
                    string[] lyssensor = (string[])al[10]; //lux
                    lys.Text = "Lys (lux): " + lyssensor[1];
                    string[] chipversion = (string[])al[26]; //chipversion
                    chip.Text = "Chip: " + chipversion[1];
                    string[] ude = (string[])al[24]; //udetemperatur
                    udetemp.Text = "Ude: " + ude[1] + gradtegn.ToString();
                    updatetime.Text = "" + DateTime.Now.Hour + ":" + DateTime.Now.Minute + ":" + DateTime.Now.Second;
                    checkSendAlarm(magasinindhold[1]);
                }
                catch (IOException fejl)
                {
                    updatetime.Text = fejl.ToString();
                }

            }
            else
            {
                
                updatetime.Text = "Indtast URL";
            }

        }

        private void indtastURLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            GemURLForm uform = new GemURLForm();
            uform.Activate();
            uform.Show();
        }

        private void sendAlarmerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Alarmform af1 = new Alarmform();
            af1.Activate();
            af1.Show();
            

        }

        private void startTimerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (File.Exists("alarm.txt"))
            {
                timer1.Enabled = true;
                StreamReader sr = new StreamReader("alarm.txt");
                string minsmtp = sr.ReadLine();
                string modtager = sr.ReadLine();
                string magasingrænse = sr.ReadLine();
                int portnummer = Convert.ToInt32(sr.ReadLine());
                string afsender = sr.ReadLine();
                string kodeord = sr.ReadLine();
                string timersekunder = sr.ReadLine();
                sr.Close();
                int talMagasinGrænse = Convert.ToInt32(magasingrænse);
                int timerinterval = (Convert.ToInt32(timersekunder) * 1000);
                timer1.Interval = timerinterval;
                updatetime.Text = "Timer startet..";
            }
            else
            {
                updatetime.Text = "Alarm.txt findes ikke";
            }
        }

        private void stopTimerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            updatetime.Text = "Timer stoppet";
        }

        private void programinfoToolStripMenuItem_Click(object sender, EventArgs e)
        {
                       
            AboutBox1 ab1 = new AboutBox1();
            ab1.Activate();
            ab1.Show();
        }

        

    }
}
